\section*{Syntax}
\begin{flalign*}
&\text{Kinds} & \kappa &::= \star \mid \kappa \to \kappa \\[.5em]   
&\text{Types} &A &::= \alpha \mid 1 \mid A \rightarrow A \mid \forall \alpha :: \kappa. A \mid \lambda \alpha :: \kappa. A \mid \Sigma \ \rho_A \mid \Pi \ \rho_A \\[0.5em]
&\text{Monotype} &\tau &::= \alpha \mid 1 \mid \tau \to \sigma \mid \lambda \alpha :: \kappa. \tau \mid \Sigma \ \rho_\tau \mid \Pi \ \rho_\tau \\[.5em]
&\text{Rows} &\rho_X &::= \cdot \mid \ell : X :: \rho \\[.5em]
&\text{Row Labels} &\ell, C &\in \textsf{Label}\\[.5em]
&\text{Terms} &f &::= x \mid () \mid \lambda x : A. f \mid f \ f \mid \Lambda \alpha :: \kappa. f \mid f \ [\tau] \\
&&&\hspace*{5mm}\mid \textsf{let } x : A = f \textsf{ in } f \mid \textsf{let rec } x : A = \lambda x. f \textsf{ in } f \\ 
&&&\hspace*{5mm}\mid C \ f \mid \textsf{match } f \textsf{ with } \overline{p \rightarrow f} \\
&&&\hspace*{5mm}\mid \{ \ \ell = f; \ldots; \ell = f \ \} \mid f.\ell \mid \{ \ f \textsf{ with } \ell = f \ \} \\ 
&&&\hspace*{5mm}\mid \textsf{let module } X : S = M \textsf{ in } f \mid P.x \\[.5em]
&\text{Patterns} &p &::= () \mid x \mid C \ p \mid \{ \ \ell = p; \ldots; \ell = p \ \}  \\[.5em]
&\text{Bindings} &B &::= \textsf{let } x : A = f\\
&&&\hspace*{5mm}\mid \textsf{type } \alpha :: \kappa = A\\
&&&\hspace*{5mm}\mid\textsf{module } X = M \\[.5em]
&\text{Module Expressions} &M &::= P.X \\
&&&\hspace*{5mm}\mid X \\
&&&\hspace*{5mm}\mid \textsf{struct } \overline{B} \textsf{ end} \\[.5em]
&\text{Paths} &P &::= X \mid P.X \\[.5em]
&\text{Declarations} &D &::= \textsf{val } x : A\\
&&&\hspace*{5mm}\mid \textsf{type } \alpha :: \kappa = A\\
&&&\hspace*{5mm}\mid \textsf{module } X : S\\[.5em]
&\text{Signature} &S &::= \textsf{sig } \overline{D} \textsf{ end}\\[.5em]
&\text{Contexts} &\Gamma &::= \cdot \mid \Gamma, x : A \mid \Gamma, \alpha :: \kappa \mid \Gamma, \textsf{module } X : S \\[0.5em]
&\text{Term Contexts} &\mathbb{T} &::= [\cdot] \mid \lambda x : A. \mathbb{T} \mid \mathbb{T} \ f \mid f \ \mathbb{T} \mid \Lambda \alpha :: \kappa. \mathbb{T} \mid \mathbb{T} \ [\tau] \\[.5em]
\end{flalign*}

\section*{Typing Rules}

\noindent$\boxed{\Gamma \textsf{ ctx}}$
\begin{mathpar}
    \inferrule*[]
        { }
        { \cdot \textsf{ ctx}}
    
    \inferrule*[]
        { \Gamma \textsf{ ctx} \\ \Gamma \vdash A :: \star \\ x \notin \dom \Gamma}
        { \Gamma, x : A \textsf{ ctx}}

    \inferrule*[]
        { \Gamma \textsf{ ctx} \\ \alpha \notin \dom \Gamma }
        { \Gamma, \alpha :: \kappa \textsf{ ctx} }

    \inferrule*[]
        { \Gamma \textsf{ ctx} \\ X \notin \dom \Gamma \\ \Gamma \vdash S \textsf{ sig}}
        { \Gamma, \textsf{module } X : S \textsf{ ctx}}
\end{mathpar}
\noindent$\boxed{\Gamma \vdash A :: \kappa}$
\begin{mathpar}
    \inferrule*[]
        {\alpha :: \kappa \in \Gamma}
        { \Gamma \vdash \alpha :: \kappa }

    \inferrule*[]
        { }
        { \Gamma \vdash 1 :: \star }

    \inferrule*[]
        { \Gamma \vdash A :: \star \\ \Gamma \vdash B :: \star }
        { \Gamma \vdash A \to B :: \star }

    \inferrule*[]
        { \Gamma, \alpha :: \kappa \vdash A :: \star }
        { \Gamma \vdash \forall \alpha :: \kappa. A :: \star }

    \inferrule*[]
        { \Gamma, \alpha :: \kappa_1 \vdash A :: \kappa_2}
        { \Gamma \vdash \lambda \alpha :: \kappa_1. A :: \kappa_1 \to \kappa_2}

    \inferrule*[]
        { \Gamma \vdash \rho \textsf{ row} }
        { \Gamma \vdash \Sigma \ \rho :: \star }

    \inferrule*[]
        { \Gamma \vdash \rho \textsf{ row}}
        { \Gamma \vdash \Pi \ \rho :: \star }
\end{mathpar}

\noindent$\boxed{\Gamma \vdash \rho \textsf{ row}}$
\begin{mathpar}
    \inferrule*[]
        { }
        { \Gamma \vdash \cdot \textsf{ row}}

    \inferrule*[]
        { \Gamma \vdash A :: \star \\ \ell \notin \dom \rho \\ \Gamma \vdash \rho \textsf{ row}}
        { \Gamma \vdash \ell : A :: \rho \textsf{ row}}
\end{mathpar}
\noindent$\boxed{\Gamma \vdash P \rhd S}$
\begin{mathpar}
    \inferrule*[]
        { \textsf{module } X : S \in \Gamma }
        { \Gamma \vdash X \rhd S }
    
    \inferrule*[]
        { \Gamma \vdash P \rhd \textsf{sig } \overline{D} \textsf{ end} \\ \textsf{module } X : S \in \overline{D}}
        { \Gamma \vdash P.X \rhd S }
\end{mathpar}
\noindent$\boxed{\Gamma \vdash S \textsf{ sig}}$
\begin{mathpar}
    \inferrule*[]
        {  }
        { \Gamma \vdash (\textsf{sig} \textsf{ end}) \textsf{ sig}}

    \inferrule*[]
        { \Gamma \vdash D \textsf{ decl} \leadsto \Delta \\ \Gamma, \Delta \vdash (\textsf{sig } \overline{D} \textsf{ end}) \textsf{ sig}}
        { \Gamma \vdash (\textsf{sig } (D, \overline{D}) \textsf{ end}) \textsf{ sig}}
\end{mathpar}
\noindent$\boxed{\Gamma \vdash D \textsf{ decl} \leadsto \Delta}$
\begin{mathpar}
    \inferrule*[]
        { \Gamma \vdash A :: \star}
        { \Gamma \vdash (\textsf{val } x : A) \textsf{ decl} \leadsto x : A}

    \inferrule*[]
        { \Gamma \vdash A :: \kappa}
        { \Gamma \vdash (\textsf{type } \alpha :: \kappa = A) \textsf{ decl} \leadsto \cdot}

    \inferrule*[]
        { \Gamma \vdash S \textsf{ sig}}
        { \Gamma \vdash (\textsf{module } X : S) \textsf{ decl} \leadsto \textsf{module } X : S}
\end{mathpar}



\noindent$\boxed{\inferrule*[]{}{\Gamma \vdash f : A}}$  
\begin{mathpar}
    
  \inferrule*[]
  { x : A \in \Gamma }
  { \Gamma \vdash x : A }

\inferrule*[]
    { }
    { \Gamma \vdash () : 1 }

\inferrule*[]
  { \Gamma \vdash A_1 :: \star \\ \Gamma, x : A_1 \vdash f : A_2}
  { \Gamma \vdash \lambda x : A_1. f : A_1 \rightarrow A_2}

\inferrule*[]
  { \Gamma \vdash f_1 : A_1 \rightarrow A_2 \\ \Gamma \vdash f_2 : A_1}
  { \Gamma \vdash f_1 \ f_2 : A_2}

\inferrule*[]
  {\Gamma, \alpha :: \kappa \vdash f : A}
  {\Gamma \vdash \Lambda \alpha :: \kappa. f : \forall \alpha. A}

\inferrule*[]
  {\Gamma \vdash f : \forall \alpha :: \kappa. A \\ \Gamma \vdash \tau :: \kappa}
  {\Gamma \vdash f \ [\tau] : A[\alpha := \tau]}

% \inferrule*[]
%     { \Gamma \vdash f : A \\ \Gamma \vdash A = B}
%     { \Gamma \vdash f : B}
\end{mathpar}
\begin{mathpar}
\inferrule*[]
    { \Gamma \vdash A :: \star \\ \Gamma \vdash f_1 : A \\ \Gamma, x : A \vdash f_2 : B }
    { \Gamma \vdash \textsf{let } x : A = f_1 \textsf{ in } f_2 : B}

\inferrule*[]
    { \Gamma \vdash A :: \star \\ \Gamma, x : A \vdash \lambda y. f_1 : A \\ \Gamma, x : A \vdash f_2 : B }
    { \Gamma \vdash \textsf{let rec } x : A = \lambda y. f_1 \textsf{ in } f_2 : B}

\inferrule*[]
    { \forall 1 \leq i \leq n. \ \Gamma \vdash f_i : A_i }
    { \Gamma \vdash \{ \ \ell_1 = f_1; \ldots; \ell_n = f_n \ \} : \Pi \ ( \ \ell_1 : A_1 :: \cdots ::  \ell_n : A_n \ )}

\inferrule*[]
    { \Gamma \vdash f : \Pi \ \rho \\ \ell : A \in \rho }
    { \Gamma \vdash f.\ell : A }

\inferrule*[]
    { \Gamma \vdash f_1 : \Pi \ \rho \\ \ell : A \in \rho \\ \Gamma \vdash f_2 : A  }
    { \Gamma \vdash \{ \ f_1 \textsf{ with } \ell = f_2 \ \} : \Pi \ \rho }

\inferrule*[]
    { \Gamma \vdash \Sigma \ \rho :: \star \\ C : A \in \rho \\ \Gamma \vdash f : A }
    { \Gamma \vdash (C \ f : \Sigma \ \rho) : \Sigma \ \rho }

\inferrule*[]
    { \Gamma \vdash f : A \\ \forall 1 \leq i \leq n. \ \Gamma \vdash p_i \to f_i : A \to B }
    { \Gamma \vdash \textsf{match } f \textsf{ with } \overline{p_i \to f_i} : B}

\inferrule*[]
    { \Gamma \vdash S \textsf{ sig} \\ \Gamma \vdash M : S \\ \Gamma, \textsf{module } X : S \vdash f : A}
    { \Gamma \vdash \textsf{let module } X : S = M \textsf{ in } f : A}

\inferrule*[]
    { \Gamma \vdash P \rhd \textsf{sig }\overline{D}\textsf{ end} \\ (\textsf{val } x : A) \in \overline{D}}
    { \Gamma \vdash P.x : A }
\end{mathpar}

{\setlength{\mathindent}{0cm}
\begin{empheq}[box=\fbox]{align*}
    \Gamma &\vdash p \to f : A \to B \\
    &\vdash p : A \leadsto \Delta
\end{empheq}}
\begin{mathpar}
    \inferrule*[]
        { \vdash p : A \leadsto \Delta \\ \Gamma, \Delta \vdash f : B}
        { \Gamma \vdash p \to f : A \to B }

    \inferrule*[]
        { }
        { \vdash () : 1 \leadsto \cdot }

    \inferrule*[]
        { }
        { \vdash x : A \leadsto x : A}

    \inferrule*[]
        { C : A \in \rho \\ \vdash p : A \leadsto \Delta }
        { \vdash C \ p : \Sigma \ \rho \leadsto \Delta }

    \inferrule*[]
        { \forall 1 \leq i \leq n. \ \vdash p_i : A_i \leadsto \Delta_i }
        { \vdash \{ \ \ell_1 = p_1; \ldots; \ell_n = p_n \ \} : \Pi \  ( \ \ell_1 : A_1 :: \cdots :: \ell_n : A_n \ ) \leadsto \Delta_1 ,\ldots, \Delta_n }
\end{mathpar}
{\setlength{\mathindent}{0cm}
\begin{empheq}[box=\fbox]{align*}
    \Gamma &\vdash M : S \\
    \Gamma &\vdash B : D 
\end{empheq}}
\begin{mathpar}
    \inferrule*[]
        { \Gamma \vdash P \rhd \textsf{sig } \overline{D} \textsf{ end} \\ (\textsf{module } X : S) \in \overline{D}}
        { \Gamma \vdash P.X : S}
    
    \inferrule*[]
        { \textsf{module } X : S \in \Gamma }
        { \Gamma \vdash X : S}

    \inferrule*[]
        { \forall 1 \leq i \leq n. \ \Gamma \vdash B_i : D_i}
        { \Gamma \vdash \textsf{struct } \overline{B} \textsf{ end} : \textsf{sig }\overline{D}\textsf{ end}}
\end{mathpar}
\begin{mathpar}
    \inferrule*[]
    { \Gamma \vdash f : A }
    { \Gamma \vdash (\textsf{let } x : A = f) : (\textsf{val } x : A)}

\inferrule*[]
    { \Gamma \vdash A :: \kappa }
    { \Gamma \vdash (\textsf{type } \alpha :: \kappa = A) : (\textsf{type } \alpha :: \kappa = A)}

\inferrule*[]
    { \Gamma \vdash M : S }
    { \Gamma \vdash (\textsf{module } X = M) : (\textsf{module } X : S)}
\end{mathpar}


% \noindent$\boxed{\Gamma \vdash A \leq B}$
% \begin{mathpar}
%     \inferrule*[]
%         { }
%         { \Gamma \vdash 1 \leq 1 }

%     \inferrule*[]
%         { \alpha :: \kappa \in \Gamma }
%         { \Gamma \vdash \alpha \leq \alpha }

%     \inferrule*[]
%         { \Gamma, \alpha :: \kappa \vdash A \leq B  }
%         { \Gamma \vdash \lambda \alpha :: \kappa. A \leq \lambda \alpha :: \kappa. B }

%     \inferrule*[]
%         { \Gamma, \alpha :: \kappa \vdash A \leq B }
%         { \Gamma \vdash \forall \alpha :: \kappa. A \leq \forall \alpha :: \kappa. B }

%     \inferrule*[]
%         { \Gamma \vdash B_1 \leq A_1 \\ \Gamma \vdash A_2 \leq B_2 }
%         { \Gamma \vdash A_1 \to A_2 \leq B_1 \to B_2 }


% \end{mathpar}
